var https = require('https');
var express = require('express');
var huddleProxy = require('./huddle-proxy');
var app = express();
var fs = require('fs');

var privateKey  = fs.readFileSync('ssl/huddlesdk.key').toString();
var certificate = fs.readFileSync('ssl/huddlesdk.cert').toString();
var credentials = {key: privateKey, cert: certificate};

function defaultRequestHandler (req, res) {
	res.writeHead(200, {'Content-Type': 'text/html'});
	var page = fs.readFileSync('./templates/default.html', 'utf8');
	res.write(page);
	res.end();
	console.log("Default page served");
}

app.use(express.bodyParser());

huddleProxy.attach(app, 'Bens%20Huddle%20hacks', 'localhost:8000', defaultRequestHandler);

app.get('/', defaultRequestHandler);

app.use('/js', express.static(__dirname + '/js'));

var https = https.createServer(credentials, app);

https.listen(8000);
console.log('Listening on port 8000');

// Shall we just setup http on 8080 to redirect to https.
// set up plain http server
var httpApp = express();

// set up a route to redirect http to https
httpApp.get('*',function(req,res){  
    res.redirect('https://localhost:8000'+req.url)
})

// have it listen on 8080
httpApp.listen(8080);